#include <stdlib.h>
#include <Math.h>

///////CNC Definitions//////
//const int STEPPERENABLE=2;

//const int XAXISDIR=A1;
//const int XAXIS=12;
//const int ZAXISDIR=4;
//const int ZAXIS=3;
//const int YAXISDIR=11;
//const int YAXIS=10;

//const int PADLEFT=7;
//const int PADRIGHT=6;
//const int PADZUP=13;
//const int PADZDOWN=5;
//const int PADUP=9;
//const int PADDOWN=8;

const int STEPPERENABLE=4;

const int XAXISDIR=5;
const int XAXIS=6;
const int ZAXISDIR=7;
const int ZAXIS=8;
const int YAXISDIR=10;
const int YAXIS=9;



unsigned int gXYSpeed=3000;
unsigned int gZSpeed=2500;
unsigned int gXYTravelSpeed=100;
unsigned int gZTravelSpeed=100;
const unsigned int gSignalDelay=50;
double gTravelHeight=-3;
double gRouteDepth=0.1;

int gCurStepX=0;
int gCurStepY=0;
int gCurStepZ=0;
double gCurX=0;
double gCurY=0;
double gCurZ=0;

/////////////////////////////

void delayUSeconds(unsigned int time){
  if (time>15000){
    unsigned int i=0;
    for (i=15000;i<time;i+=15000){
      delayMicroseconds(15000); 
    }
    i-=15000;
    delayMicroseconds(time-i);
  }else{
    delayMicroseconds(time); 
  }
}

void gotoZ(double dToZ,unsigned int speedDelay){
	int toz=((double)dToZ*400.0f);
	int steps=(gCurStepZ-toz);
        if (steps==0) return;
	if (steps>0){
          digitalWrite(ZAXISDIR,1);
	}else{
          digitalWrite(ZAXISDIR,0);
	}
        steps=abs(steps);
	for (int i=0;i<steps;i++){
          digitalWrite(ZAXIS,1);  
          delayUSeconds(gSignalDelay);
          digitalWrite(ZAXIS,0);
          delayUSeconds(speedDelay);  
	}
	gCurStepZ=toz;
	gCurZ=((double)gCurStepZ)/400.0f;
}

void gotoXY(double mx,double my,unsigned int speedDelay){
  int tox=(double)mx*80.0f;
  int toy=(double)my*80.0f;
  if (tox==gCurStepX && toy==gCurStepY) return;
  double xTo,yTo;
  double ratio=0;
  int xstep=1;
  int ystep=1;
  xTo=tox-gCurStepX;
  yTo=toy-gCurStepY;
  if (xTo<0){
    xstep=-1;
    digitalWrite(XAXISDIR,0);
  }else{
    digitalWrite(XAXISDIR,1);
  }
  if (yTo<0){
    ystep=-1;
    digitalWrite(YAXISDIR,1);
  }else{
    digitalWrite(YAXISDIR,0);
  }
  xTo=abs(xTo);
  yTo=abs(yTo);
  if (xTo>=yTo){
    if (yTo!=0) ratio=xTo/yTo;
    for (int i=0;i<xTo;i++){
      if (ratio!=0){
        if (!(int)fmod((double)i,ratio)){
          gCurStepY+=ystep;
          digitalWrite(YAXIS,1);  
        }
      } 
      gCurStepX+=xstep;
      digitalWrite(XAXIS,1);
      delayUSeconds(gSignalDelay);
      digitalWrite(YAXIS,0);
      digitalWrite(XAXIS,0);
      delayUSeconds(speedDelay); 
    }
  }else{
    if (xTo!=0) ratio=yTo/xTo;
    for (int i=0;i<yTo;i++){
      if (ratio!=0){
        if (!(int)fmod((double)i,ratio)){
          gCurStepX+=xstep;
          digitalWrite(XAXIS,1);  
        }
      } 
      gCurStepY+=ystep;
      digitalWrite(YAXIS,1);
      delayUSeconds(gSignalDelay);
      digitalWrite(YAXIS,0);
      digitalWrite(XAXIS,0);
      delayUSeconds(speedDelay);  
    }
  }
  while (abs(gCurStepX)!=abs(tox)){
    gCurStepX+=xstep;
    digitalWrite(XAXIS,1);  
    delayUSeconds(gSignalDelay);
    digitalWrite(XAXIS,0);
    delayUSeconds(speedDelay);  
  }
  while (abs(gCurStepY)!=abs(toy)){
    gCurStepY+=ystep;
    digitalWrite(YAXIS,1);  
    delayUSeconds(gSignalDelay);
    digitalWrite(YAXIS,0);
    delayUSeconds(speedDelay);  
  }
  gCurX=((double)gCurStepX)/80.0;
  gCurY=((double)gCurStepY)/80.0;
}

void box(double xm,double ym,double xm2,double ym2){
  gotoZ(gTravelHeight,gZTravelSpeed);
  gotoXY(xm,ym,gXYTravelSpeed);
  gotoZ(gTravelHeight/2,gZTravelSpeed);
  gotoZ(gRouteDepth,gZSpeed);
  gotoXY(xm2,ym,gXYSpeed);
  gotoXY(xm2,ym2,gXYSpeed);
  gotoXY(xm,ym2,gXYSpeed);
  gotoXY(xm,ym,gXYSpeed);
  gotoZ(gTravelHeight,gXYTravelSpeed);
}

void line(double xm,double ym,double xm2,double ym2){
  gotoZ(gTravelHeight,gZTravelSpeed);
  gotoXY(xm,ym,gXYTravelSpeed);
  gotoZ(gTravelHeight/2,gZTravelSpeed);
  gotoZ(gRouteDepth,gZSpeed);
  gotoXY(xm2,ym2,gXYSpeed);
  gotoZ(gTravelHeight,gZTravelSpeed);
}

void circle(double xm,double ym,double rad){
  double sides=36;
  double angle=0;
  gotoZ(gTravelHeight,gZTravelSpeed);
  gotoXY(xm+rad,ym,gXYTravelSpeed);
  gotoZ(gTravelHeight/2,gZTravelSpeed);
  gotoZ(gRouteDepth,gZSpeed);
  
  for (double angle=0;angle<(6.28+6.28/sides);angle+=6.28/sides){ 
    gotoXY(xm+rad*cos(angle),ym+rad*sin(angle),gXYSpeed);
  }
  gotoZ(gTravelHeight,gZTravelSpeed);
}

void drill(double xm,double ym){
 gotoZ(gTravelHeight,gZTravelSpeed);
 gotoXY(xm,ym,gXYTravelSpeed);
 gotoZ(gTravelHeight/2,gZTravelSpeed);
 gotoZ(gRouteDepth,gZSpeed);
 gotoZ(gTravelHeight,gZTravelSpeed);
}




///////////////////////////////////////////////////////////////////////////////////

void setup() {
  Serial.begin(9600);
  pinMode(STEPPERENABLE,OUTPUT);
  digitalWrite(STEPPERENABLE,1);
  pinMode(XAXIS, OUTPUT);
  pinMode(XAXISDIR, OUTPUT);
  pinMode(YAXIS, OUTPUT);
  pinMode(YAXISDIR, OUTPUT);
  pinMode(ZAXIS, OUTPUT);
  pinMode(ZAXISDIR, OUTPUT);
  
  //pinMode(PADLEFT,INPUT);
  //pinMode(PADRIGHT,INPUT);
  //pinMode(PADZUP,INPUT);
  //pinMode(PADZDOWN,INPUT);
  //pinMode(PADUP,INPUT);
  //pinMode(PADDOWN,INPUT);
  
  //digitalWrite(PADLEFT,1);
  //digitalWrite(PADRIGHT,1);
  //digitalWrite(PADZUP,1);
  //digitalWrite(PADZDOWN,1);
  //digitalWrite(PADUP,1);
  //digitalWrite(PADDOWN,1);
}



///////Interpreter definitions////
const unsigned char _UNKNOWN=0;
const unsigned char _LINE=1;
const unsigned char _RECT=2;
const unsigned char _CIRCLE=3;
const unsigned char _DRILL=4;
const unsigned char _SPEED=5;
const unsigned char _GOTOXY=6;
const unsigned char _GOTOZ=7;
const unsigned char _RELATIVE=8;
const unsigned char _ABSOLUTE=9;
const unsigned char _ROUTE=10;
const unsigned char _TRAVEL=11;
const unsigned char _ZERO=12;
const unsigned char _HOME=13;
const unsigned char _DEPTH=14;
const unsigned char _ZEROZ=15;
const unsigned char _STEPON=16;
const unsigned char _STEPOFF=17;
const unsigned char _KEYENABLE=18;
const unsigned char _KEYDISABLE=19;

const int CMDBUFF_SIZE=64;
unsigned char gKeyPadDisabled=0;
char gCmdBuff[CMDBUFF_SIZE];
char gCmdLen=0;
int gLookPos=0;
char gLook=0;
unsigned char gHasError=0;
//////////////////////////////////

void loop() {
  unsigned char wasMoved=0;
  if (Serial.available()>0){
    gCmdBuff[gCmdLen++]=Serial.read();
    if (gCmdLen>CMDBUFF_SIZE){
      gCmdLen=0;
      Serial.print("ERR: Buffer overflow;");//Recieve buffer overflow
    }
    if (gCmdBuff[gCmdLen-1]==';'){
      gCmdLen--;
      interpretCommand();
      gCmdLen=0;
    }
  }
/*  if (gKeyPadDisabled==0){
    wasMoved=0;
    if (!digitalRead(PADUP)){
      gotoXY(gCurX,gCurY-0.5,gXYTravelSpeed);
      wasMoved=1;
    }
    if (!digitalRead(PADDOWN)){
      gotoXY(gCurX,gCurY+0.5,gXYTravelSpeed);
      wasMoved=1;
    }
    if (!digitalRead(PADLEFT)){
      gotoXY(gCurX-0.5,gCurY,gXYTravelSpeed);
      wasMoved=1;
    }
    if (!digitalRead(PADRIGHT)){
      gotoXY(gCurX+0.5,gCurY,gXYTravelSpeed);
      wasMoved=1;
    }
    if (!digitalRead(PADZUP)){
      gotoZ(gCurZ-0.05,gZTravelSpeed);
      wasMoved=1;
    }
    if (!digitalRead(PADZDOWN)){
      gotoZ(gCurZ+0.05,gZTravelSpeed);
      wasMoved=1;
    }
    if (wasMoved){
      delay(100); 
    }
  }*/
}


unsigned char getChar(void){
  if (gLookPos<=CMDBUFF_SIZE-1){
    gLook=gCmdBuff[gLookPos++];
    return 1; 
  }
  gHasError=1;
  return 0;
}

unsigned char getCmd(void){
  unsigned char cmd=gLook;
  getChar();
  switch (cmd){
    case '+':
      return _KEYENABLE;
    case '-':
      return _KEYDISABLE;
    case '>':
      return _STEPON;
    case '.':
      return _STEPOFF;
    case 'L':
    case 'l':
      return _LINE;
    case 'R':
    case 'r':
      return _RECT;
    case 'C':
    case 'c':
      return _CIRCLE;
    case 'D':
    case 'd':
      return _DRILL;
    case 'S':
    case 's':
      return _SPEED;
    case 'G':
    case 'g':
      return _GOTOXY;
    case 'Z':
    case 'z':
      return _GOTOZ;
    case 'T':
    case 't':
      return _TRAVEL;
    case 'M':
    case 'm':
      return _ROUTE;
    case 'A':
    case 'a':
      return _ABSOLUTE;
    case 'F':
    case 'f':
      return _RELATIVE;
    case '0':
      return _ZERO;
    case 'H':
    case 'h':
      return _HOME;
    case 'i':
    case 'I':
      return _DEPTH;
    case 'E':
    case 'e':
      return _ZEROZ;
  }
  return _UNKNOWN;
}

float getFloat(void){
  char numBuff[16];
  unsigned char numBuffLen=0;
  unsigned char hasDec=0;
  while (numBuffLen<16 && ((gLook=='-' && numBuffLen==0) || (gLook=='+' && numBuffLen==0) || isDigit(gLook) ||  (gLook=='.' && hasDec==0))){ 
    if (gLook=='.'){
      hasDec=1; 
    }
    numBuff[numBuffLen++]=gLook;
    if (!getChar()){
      break; 
    }
  }
  if (numBuffLen==0){
    Serial.print("ERR: No float;");//no number where there should be
    gHasError=1; 
  }
  numBuff[numBuffLen]=0;
  return atof(numBuff);
}
int getInt(void){
  char numBuff[16];
  unsigned char numBuffLen=0;
  while (numBuffLen<16 && ((gLook=='-' && numBuffLen==0) || (gLook=='+' && numBuffLen==0) || isDigit(gLook))){ 
    numBuff[numBuffLen++]=gLook;
    if (!getChar()){
      break;
    }
  }
  if (numBuffLen==0){
    Serial.print("ERR: No int;");//no number where there should be
    gHasError=1; 
  }
  numBuff[numBuffLen]=0;
  return atoi(numBuff);
}

void match(unsigned char character){
  if (gLook!=character){
    Serial.print("ERR: Wrong match;");
    gHasError=1;
  }else{
    getChar();
  }
}

#define CHKERR if (gHasError) return;

void interpretCommand(void){
  float x,y,x2,y2,z;
  unsigned char flag;
  unsigned int xi,yi;
  gHasError=0;
  gLookPos=0;
  getChar();
  CHKERR;
  
  switch (getCmd()){
    case _KEYENABLE:
      gKeyPadDisabled=1;
      break;
    case _KEYDISABLE:
      gKeyPadDisabled=0;
      break;
    case _STEPON:
      digitalWrite(STEPPERENABLE,0);
      break;
    case _STEPOFF:
      digitalWrite(STEPPERENABLE,1);
      break;
    case _LINE:
      x=getFloat();CHKERR;
      match(',');CHKERR;
      y=getFloat();CHKERR;
      match(',');CHKERR;
      x2=getFloat();CHKERR;
      match(',');CHKERR;
      y2=getFloat();CHKERR;
      line(x,y,x2,y2);
      break;
    case _RECT:
      x=getFloat();CHKERR;
      match(',');CHKERR;
      y=getFloat();CHKERR;
      match(',');CHKERR;
      x2=getFloat();CHKERR;
      match(',');CHKERR;
      y2=getFloat();CHKERR;
      box(x,y,x2,y2);
      break;
    case _CIRCLE:
      x=getFloat();CHKERR;
      match(',');CHKERR;
      y=getFloat();CHKERR;
      match(',');CHKERR;
      z=getFloat();CHKERR;
      circle(x,y,z);
      break;
    case _DRILL:
      x=getFloat();CHKERR;
      match(',');CHKERR;
      y=getFloat();CHKERR;
      drill(x,y);
      break;
    case _DEPTH:
      x=getFloat();CHKERR;
      gRouteDepth=x;
      break;
    case _SPEED:
      switch (getCmd()){
        case _TRAVEL:
          xi=getInt();CHKERR;
          match(',');CHKERR;
          yi=getInt();CHKERR;
          gXYTravelSpeed=xi;
          gZTravelSpeed=yi;
          break;
        case _ROUTE:
          xi=getInt();CHKERR;
          match(',');CHKERR;
          yi=getInt();CHKERR;
          gXYSpeed=xi;
          gZSpeed=yi;
          break;
        default:
          Serial.print("ERR: irrelevant modifier;"); 
          break;
      }
      break;
    case _GOTOXY:
      flag=getCmd();CHKERR;
      x=getFloat();CHKERR;
      match(',');CHKERR;
      y=getFloat();CHKERR;
      if (flag==_RELATIVE){
        gotoXY(gCurX+x,gCurY+y,gXYTravelSpeed);
      }else if (flag==_ABSOLUTE){
        gotoXY(x,y,gXYTravelSpeed);
      }else{
        Serial.print("ERR: irrelevant modifier;"); 
      }
      break;
    case _GOTOZ:
      flag=getCmd();CHKERR;
      x=getFloat();CHKERR;
      if (flag==_RELATIVE){
        gotoZ(x+gCurZ,gZTravelSpeed);
      }else if (flag==_ABSOLUTE){
        gotoZ(x,gZTravelSpeed);
      }else{
        Serial.print("ERR: irrelevant modifier;"); 
      }
      break;
    case _TRAVEL:
      x=getFloat();CHKERR;
      gTravelHeight=0-x;
      break;
    case _HOME:
      gotoZ(gTravelHeight,gZTravelSpeed);
      gotoXY(0,0,gXYTravelSpeed);
      gotoZ(0,gZTravelSpeed);
      break;
    case _ZEROZ:
      gCurZ=0;
      gCurStepZ=0;
      break;
    case _ZERO:
      gCurX=0;
      gCurY=0;
      gCurZ=0;
      gCurStepX=0;
      gCurStepY=0;
      gCurStepZ=0;
      break;
    default:
      Serial.print("ERR: Unknown command;");
      gHasError=1;CHKERR;
      break;
  }
  match(';');CHKERR;
  Serial.print("!");
}
